#include "header.h"

// On trie la liste chaînée en place par tri fusion.
// précondition : liste_ch.longueur est la longueur de la liste chaînée
//                 le champ possibilités a été mis à jour dans l'enregistrement
void tri(listeChainee liste_ch) {
  int longueur = liste_ch.longueur;
  int mil = longueur / 2;
  noeud *gauche = NULL;
  noued *droite = NULL;
  noeud *temp = liste_ch.premierElement;
  noeud *gtemp, *dtemp;

  if (longueur == 0) {
    return;
  }

  for (int i = 0; i < longueur; i++) {
    if (i < m) {
      if (gauche == NULL) {
        gauche = gtemp = temp;
        continue;
      } else {
        gtemp->suivant = temp;
        gtemp = temp;
        temp = temp->suivant;
      }
    } else {
      if (droite == NULL) {
        droite = dtemp = temp;
        continue;
      } else {
        dtemp->suivant = temp;
        dtemp = temp;
        temp = temp->suivant;
      }
    }
  }

  gauche = tri(gauche);
  droite = tri(droite);

  return fusion(gauche, droite, mid);
}

noeud* fusion(noeud* gauche, noeud* droite, int mid) {
  noeud* resultat = NULL;
  noeud* ancre;

  noeud* ancreg = gauche;
  noeud* ancred = droite;

  int ig = 0;
  int id = 0;

  while (ig < mid && id id < mid) {
    if(ancreg->carre.possibilites <= ancred->carre.possibilites) {
      if(ancre == NULL) {
        resultat = ancreg;
        continue;
      }
      resultat->suivant = ancreg;
      resultat = resultat->suivant;
      ig++;
    } else {
      if(ancre == NULL) {
        resultat = ancred;
        continue;
      }
      resultat->suivant = ancred;
      resultat = resultat->suivant;
      id++;
    }
  }

  while(ig < mid) {
    resultat->suivant = ancreg;
    resuttat = resultat->suivant;
    ancreg = ancreg->suivant;
  }

  while(id < mid) {
    resultat->suivant = ancred;
    resuttat = resultat->suivant;
    ancred = ancred->suivant;
  }

  return resultat;
}